import { fetchSchema, fetchSchemaFromMap } from "../common/SchemaFetch";
export const schemaFromConfig = async (schemaConfig, formItemConfigOverrides, propertyOverrides, dynamicKey) => {
    let schema = undefined;
    if (schemaConfig.schemaProvider != null)
        schema = await fetchSchema(schemaConfig.schemaProvider, formItemConfigOverrides, propertyOverrides, dynamicKey);
    else if (schemaConfig.registeredSchemaKey != null) {
        schema = await fetchSchemaFromMap(schemaConfig.registeredSchemaKey, formItemConfigOverrides, propertyOverrides, dynamicKey);
        if (schema == null)
            throw Error("Schema not found in registered schemas. Please remember to register your schema by using 'formbuilder.registerSchema' or by supplying the schemaprovider directly in the formbuilder props using the 'schemaConfig' prop");
    }
    return schema;
};
//# sourceMappingURL=schemaFromConfig.js.map